1 / 33

Zero to 3D in 60 Minutes

Zero to 3D in 60 Minutes. Fenton Webb Senior Developer Evangelist. About the Presenter. Fenton Webb Developer Technical Services Americas Autodesk, Inc http://twitter.com/fentonwebb

aulii
Télécharger la présentation

Zero to 3D in 60 Minutes

An Image/Link below is provided (as is) to download presentation Download Policy: Content on the Website is provided to you AS IS for your information and personal use and may not be sold / licensed / shared on other websites without getting consent from its author. Content is provided to you AS IS for your information and personal use only. Download presentation by click this link. While downloading, if for some reason you are not able to download a presentation, the publisher may have deleted the file from their server. During download, if you can't get a presentation, the file might be deleted by the publisher.

E N D

Presentation Transcript


  1. Zero to 3D in 60 Minutes Fenton Webb Senior Developer Evangelist

  2. About the Presenter Fenton WebbDeveloper Technical ServicesAmericasAutodesk, Inc http://twitter.com/fentonwebb Fenton has been a member of the Autodesk DevTech team since 2000. Originally a member of our EMEA team, he has recently relocated to California to work for DevTech Americas.  Fenton is an expert in all the AutoCAD APIs, AutoCAD OEM, RealDWG and Revit. He particularly enjoys travelling to evangelise the APIs he support at our annual Developer Days conferences.  Before joining Autodesk, Fenton worked for an ADN partner developing ObjectARX applications in the Civil and Structural Engineering domain.

  3. Autodesk Developer Network • Access to almost all Autodesk software and SDK’s • Including early access to Beta software • Members-only website with 1000s of technical articles • Unlimited technical support • Product direction through conferences • Marketing benefits • Exposure on autodesk.com • Promotional opportunities • 1 to 3 free API training classes • Based on user level www.autodesk.com/joinadn

  4. DevLab • San Francisco, USA Feb 1-5, 2010 • Farnborough, UK Feb 8-12, 2010 • Munich, Germany June 7-11, 2010 • Other countries TBD • www.autodesk.com/apitraining > Schedule • stephen.preston@autodesk.com

  5. Agenda History of 3D in AutoCAD Creating 3D Geometry Creating Advanced 3D Geometry Logical - Unions, Subtracts and Intersect Geometrical - Extrusions, Lofts, Revolves and Sweeps Freeform Modeling Extract the 3D Data Questions

  6. History of 3D in AutoCAD Technology Information • Version 2.1 • Z Coordinate • R11 AutoCAD Modeling Extension (AME) • ADS API • R13 ACIS - Licensed Technology from Spatial • Industry Standard • SAT Output • 2004 ASM – Autodesk Solid Modeler • Derived from ACIS • Autodesk Standard • Amodeler – Autodesk Modeler • Focused Surface Modeler used by ADT/AutoCAD Architecture

  7. Creating 3D Geometry Using AutoCAD Easy to Create Basic 3D Geometry – Solid Types • Known as Primitive Solids • Commands • Box, Wedge, Cone, Cylinder, Sphere, Pyramid, Torus • See AutoCAD Help Create 3D Solid Primitives

  8. Creating 3D Geometry Using AutoCAD You can easily modify Primitive Solids • Via the Properties Window • Via Grips • Basic Properties • Keeps Shape

  9. Creating 3D Geometry Using AutoCAD Advanced modification is possible • Sub-Object Selection (CTRL+Left Click) • Faces • Edges • Vertices

  10. Creating 3D Geometry Using APIs .NET Solid3d.Create* CreateBox, CreateSphere, CreateTorus, etc ObjectARX AcDb3dSolid::create* createBox, CreateSphere, CreateTorus , etc VBA or Visual LISP Active X Acad3dSolid.Add* AddBox, AddSphere, AddTorus, etc LISP Command Line method ActiveX LISP (using the same API as VBA)

  11. Creating 3D Geometry Show how... Demo “Basic 3D” Demonstrating Visual Studio 2008 Using Solid3d class Using C# .NET

  12. Creating Advanced 3D Geometry Using Logical Operations Synthesizing Solids • Union • Subtract • Intersect

  13. Creating Advanced 3D Geometry Using Logical Operations Synthesizing Solids • Union • Combine

  14. Creating Advanced 3D Geometry Using Logical Operations Synthesizing Solids • Subtract

  15. Creating Advanced 3D Geometry Using Logical Operations Synthesizing Solids • Intersect • Common

  16. Creating 3D Geometry Show how... Demo “Logical 3D” Demonstrating Logical Solid3D Operations Union Subtract Intersect Using C# .NET

  17. Creating Advanced 3D Geometry Using AutoCAD Extrude, Loft, Revolve and Sweep - Surface (and Solid) Types

  18. Creating Advanced 3D Geometry Using AutoCAD You can modify these types • Via the Properties Window • Via Grips • Construction Geometry Only

  19. Creating Advanced 3D Geometry Using AutoCAD Advanced modification not possible Sub-Object Selection (CTRL+Left Click) Faces Edges Vertices

  20. Creating Advanced 3D Geometry Using APIs .NET Extrude SweepOptions / SweepOptionsBuilder ExtrudedSurface.CreateExtrudedSurface Sweep SweepOptions /SweepOptionsBuilder SweptSurface.CreateSweptSurface Loft LoftOptions / LoftOptionsBuilder Solid3d.CreateLoftedSolid Revolve RevolveOptions / RevolveOptionsBuilder Solid3d.CreateRevolvedSolid Surface Type Surface Type Solid Type Solid Type

  21. Creating Advanced 3D Geometry Using APIs ObjectARX Extrude AcDbSweepOptions AcDbExtrudedSurface::createExtrudedSurface Sweep AcDbSweepOptions AcDbSweptSurface::createSweptSurface Loft AcDbLoftOptions AcDb3dSolid::createLoftedSolid Revolve AcDbRevolveOptions AcDb3dSolid::createRevolvedSolid Surface Type Surface Type Solid Type Solid Type

  22. Creating Advanced 3D Geometry Using APIs VBA or Visual LISP ActiveX Extrude AddExtrudedSolid Sweep SweptSurface – Read Only Loft LoftedSurface– Read Only Revolve AddRevolvedSolid Surface Type Surface Type Solid Type Solid Type

  23. Creating Advanced 3D Geometry Show how... Demo “Advanced 3D” Demonstrating Extrudes Lofts Sweeps Revolves Using C# .NET

  24. Freeform Modeling Realisations New features Required Unique Style of Modeling • Takes 3D Modeling to the next level! Quicker and easier Special Gadgets ASM Solids Are Very Powerful Great at Everything What about DWG compatibility? Face limitation (32k)

  25. Freeform Modeling New API New SubDMesh entity Uses Catmull-Clark algorithm Edge and surface creasing No 32k face limit API Available in • ObjectARX – AcDbSubDMesh • .NET - SubDMesh

  26. Freeform Modeling What is SubD A subdivision surface is a smooth surface created from a coarse mesh. The smooth surface is calculated by iteratively subdividing each polygonal face into smaller faces that better approximate the smooth surface. • See http://en.wikipedia.org/wiki/Subdivision_surface

  27. Freeform Modeling Show how... Demo “Freeform Modeling” Demonstrating • Freeform Modeling SDK Sample Create from primitive Create from ASM solid Applying creases Transform mesh elements Convert to ASM solid Using VB.NET

  28. Extract the 3D Data Introducing Brep Boundary Representation Brep ObjectARX and .NET • Solids • Regions • Bodies • Surfaces* • Represents shapes using Limits • Limits defined using hierarchically connected objects • Otherwise known as Topology

  29. Extract the 3D Data How Brep works Boundaries gives Faces, Faces gives Edges Geometric information are associated with three basic entities ( Surfacesfaces, Curvesedges, PointsVertices )

  30. Extract the 3D Data Show how... Demo “Brep” Demonstrating Visual Studio 2008 Extracting 3D Data from a Solid Using C# .NET

  31. Zero to 3D Further reading... SDK and Samples www.objectarx.com Developer Center www.autodesk.com/developautocad Discussion Groups http://discussion.autodesk.com API Training Classes www.autodesk.com/apitraining Kean’s Through the Interface Blog http://blogs.autodesk.com/through-the-interface Autodesk Developer Network www.autodesk.com/joinadn

  32. Zero to 3D in 60 Minutes Fenton Webb Senior Developer Evangelist Thank you – Any questions?

More Related